// KickAssembler
// 2020 Cyprian Konador

.var LZ4_SRC	= $00+$80
.var LZ4_DST	= $02+$80
.var LZ4_END	= $04+$80
.var COUNT	= $06+$80
.var DELTA	= $08+$80

.var Licznik	= $0a+$80
.var Licznik_2	= 10


//; Autostart header (BASIC byte code)
BasicUpstart2(Start)


//; Start of program, specified in BASIC header
	* = $1000
Start:
	sei			// Stop Interrupt

//HW init
	InitHW()


	BeepOFF()


	WaitForKbd()


	lda	#Licznik_2	// Test counter
	sta	Licznik


	BeepON()


//Main loop
Main_Loop:
//LZ4 init
		lda	#<LZ4_DataA8		// LZ4 Source Start
		sta	LZ4_SRC
		lda	#>LZ4_DataA8
		sta	LZ4_SRC+1

		lda	#<LZ4_Data_EndA8	// LZ4 Source End
		sta	LZ4_END
		lda	#>LZ4_Data_EndA8
		sta	LZ4_END+1

		lda	#<ScreenData		// Destination
		sta	LZ4_DST
		lda	#>ScreenData
		sta	LZ4_DST+1


//LZ4 go
		jsr	lz4_decode


		dec	Licznik
		beq	Neverending_Loop


//LZ4 init
		lda	#<LZ4_Data
		sta	LZ4_SRC
		lda	#>LZ4_Data
		sta	LZ4_SRC+1

		lda	#<LZ4_Data_End
		sta	LZ4_END
		lda	#>LZ4_Data_End
		sta	LZ4_END+1

		lda	#<ScreenData
		sta	LZ4_DST
		lda	#>ScreenData
		sta	LZ4_DST+1


//LZ4 go
		jsr	lz4_decode


		dec	Licznik
		beq	Main_Loop_End


	jmp	Main_Loop
Main_Loop_End:


	BeepOFF()


Neverending_Loop:
		nop
	jmp Neverending_Loop


#import "C64_LZ4_macro.asm"

#import "lz4_decode_CK_KA.asm"


//; Bitmap data location
	* = $2000
ScreenData:
	.import binary "C64_IMAGE.RAW"


//; LZ4 data location
	* = $4000
LZ4_Data:
	.import binary "C64_IMAGE_STRIP.LZ4"
LZ4_Data_End:

LZ4_DataA8:
	.import binary "A8_IMAGE_STRIP.LZ4"
LZ4_Data_EndA8:


//; Color data location (screen memory)
	* = $0C00
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $10, $10, $10, $10
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $10, $10, $10, $10, $10, $10, $20, $20, $20
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $10, $10, $10, $10, $20, $20, $20, $20, $20, $20, $20, $30
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $10, $10, $10, $10, $20, $20, $20, $20, $20, $30, $30, $30, $30, $30
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $10, $10, $10, $20, $20, $20, $20, $30, $30, $30, $30, $30, $40, $40, $40
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $10, $10, $20, $20, $20, $20, $30, $30, $30, $30, $40, $40, $40, $40, $50, $50
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $10, $20, $20, $20, $20, $30, $30, $30, $40, $40, $40, $40, $50, $50, $50, $60
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $10, $10, $20, $20, $20, $30, $30, $30, $40, $40, $40, $50, $50, $50, $60, $60, $60
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $10, $20, $20, $20, $30, $30, $30, $40, $40, $50, $50, $50, $60, $60, $60, $70, $70
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $10, $20, $20, $30, $30, $30, $40, $40, $50, $50, $50, $60, $60, $70, $70, $70, $80
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $10, $20, $20, $30, $30, $30, $40, $40, $50, $50, $60, $60, $60, $70, $70, $80, $80, $90
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $10, $20, $20, $30, $30, $40, $40, $50, $50, $60, $60, $70, $70, $80, $80, $80, $90, $90
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $20, $20, $30, $30, $40, $40, $50, $50, $60, $60, $70, $70, $80, $80, $90, $90, $A0, $A0
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $20, $20, $30, $30, $40, $40, $50, $50, $60, $70, $70, $80, $80, $90, $90, $A0, $A0, $B0
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $20, $20, $30, $40, $40, $50, $50, $60, $60, $70, $80, $80, $90, $90, $A0, $B0, $B0, $C0
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $10, $20, $30, $30, $40, $40, $50, $60, $60, $70, $80, $80, $90, $90, $A0, $B0, $B0, $C0, $C0
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $10, $20, $30, $30, $40, $50, $50, $60, $70, $70, $80, $90, $90, $A0, $B0, $B0, $C0, $D0, $D0
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $20, $20, $30, $40, $40, $50, $60, $60, $70, $80, $80, $90, $A0, $B0, $B0, $C0, $D0, $D0, $E0
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $20, $20, $30, $40, $50, $50, $60, $70, $70, $80, $90, $A0, $A0, $B0, $C0, $D0, $D0, $E0, $F0
	.byte	$E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $E6, $10, $20, $30, $30, $40, $50, $60, $60, $70, $80, $90, $90, $A0, $B0, $C0, $C0, $D0, $E0, $F0, $F0




