// KickAssembler
// 2020 Cyprian Konador
// v2 8580 Beep

.macro InitHW() {
	lda #$0B		//; Dark gray
	sta $D020		//; Border color

	// lda $D011
	// ora #$20		//; Set bitmap mode
	lda #$3B		//bitmap mode, screen on, 25 row, vertical scroll??
	// lda #$0B		//turn screen off
	// lda #$00		//turn screen off
	sta $D011

	// lda $D016
	// ora #%00001000	//; 40column
	// and #%11101111	//; non-multicolor mode
	lda #$08		//; 40column
	sta $D016

	lda $D018
	ora #$38		//; Set screen memory to $0c00, bitmap location to $2000
	sta $D018
}

.macro BeepON() {
	lda	#$0F
	sta	$D418 		// SID filter / volume
}

.macro BeepOFF() {
	lda #$FF
	sta $D406
	sta $D406+7
	sta $D406+14
	lda #$49
	sta $D404
	sta $D404+17
	sta $D404+14

	lda	#$00
	sta	$D418 		// SID filter / volume
}

.macro WaitForKbd() {
	lda #%11111111		// CIA#1 port A = outputs
	sta $DC02		// CIA#1 (Data Direction Register A)

	lda #%00000000		// CIA#1 port B = inputs
	sta $DC03		// CIA#1 (Data Direction Register B)

	lda #%01111111		// testing column COL1 https://www.c64-wiki.com/wiki/Keyboard
	sta $DC00		// CIA#1 (Port Register A)
WaitForKbd_Loop:
		lda $DC01	// CIA#1 (Port Register B)
		and #%00010000	// masking ROW4
	bne WaitForKbd_Loop	// wait until SPACE
}

