// MAD Assembler
// 2020 Cyprian Konador

LZ4_SRC	= $00+$80	// ; 25:10   (size=7c)
LZ4_DST	= $02+$80 	// ; 0c:00
LZ4_END	= $04+$80 	// ; 25:8c
COUNT	= $06+$80
DELTA	= $08+$80

Licznik	= $0a+$80
Licznik2	= 10


//; Autostart header
        org $2e0
        dta <start, >start


//; Start of program
	org $1000
start:
	sei			// Stop Interrupt


	InitHW


	BeepOFF


	WaitForKbd


	lda	#Licznik2	// Test counter
	sta	Licznik


	BeepON


//Main loop
Main_Loop
//LZ4 init
		lda	#<LZ4_DataC64		// LZ4 Source Start
		sta	LZ4_SRC
		lda	#>LZ4_DataC64
		sta	LZ4_SRC+1

		lda	#<LZ4_Data_EndC64	// LZ4 Source End
		sta	LZ4_END
		lda	#>LZ4_Data_EndC64
		sta	LZ4_END+1

		lda	#<ScreenData		// Destination
		sta	LZ4_DST
		lda	#>ScreenData
		sta	LZ4_DST+1


//LZ4 go
		jsr	lz4_decode


		dec	Licznik
		beq	Neverending_Loop


//LZ4 init
		lda	#<LZ4_Data
		sta	LZ4_SRC
		lda	#>LZ4_Data
		sta	LZ4_SRC+1

		lda	#<LZ4_Data_End
		sta	LZ4_END
		lda	#>LZ4_Data_End
		sta	LZ4_END+1

		lda	#<ScreenData
		sta	LZ4_DST
		lda	#>ScreenData
		sta	LZ4_DST+1


//LZ4 go
		jsr	lz4_decode


		dec	Licznik
		beq	Main_Loop_End


	jmp	Main_Loop
Main_Loop_End:


	BeepOFF


Neverending_Loop:
		nop
	jmp Neverending_Loop

	icl "A8_LZ4_macro.asm"
	icl "lz4_decode_CK.s"


//Data
DisplayList
	dta $70,$70,$30				; 20 blank lines
	dta $4F,<ScreenData,>ScreenData		; mode F @ Bitmapa
	:99 dta $0f				; x99  mode F
	dta $4F,<(ScreenData+4000),>(ScreenData+4000)	; mode F @ Bitmapa+4000
	:99 dta $0f				; x99  mode F
	dta $41,<DisplayList,>DisplayList	; waitvbl


//; Bitmap data location
	org $2060
ScreenData:
	ins "A8_IMAGE.RAW"


//; LZ4 data location
	org $4000
LZ4_Data:
	ins "A8_IMAGE_STRIP.LZ4"
LZ4_Data_End:

LZ4_DataC64:
	ins "C64_IMAGE_STRIP.LZ4"
LZ4_Data_EndC64:
